// MyListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "diff_trace.h"
#include "MyListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListCtrl


LV_ITEM lvi ={LVIF_TEXT | LVIF_IMAGE | LVIF_STATE,0,0,0,0xFFFF,sbuffer,sizeof(sbuffer),0,0,0};
/*
    UINT mask;
    int iItem;
    int iSubItem;
    UINT state;
    UINT stateMask;
    LPSTR pszText;
    int cchTextMax;
    int iImage;
    LPARAM lParam;
#if (_WIN32_IE >= 0x0300)
    int iIndent;

*/
CMyListCtrl::CMyListCtrl()
{
	m_bFullRowSel = FALSE;
	m_bClientWidthSel = TRUE;

	m_cxClient = 0;
	m_cxStateImageOffset = 1;
	ColumnSort=0;

	m_clrText = ::GetSysColor(COLOR_WINDOWTEXT);
	m_clrTextBk = ::GetSysColor(COLOR_WINDOW);
	m_clrBkgnd = ::GetSysColor(COLOR_WINDOW);

}

CMyListCtrl::~CMyListCtrl()
{
}


BEGIN_MESSAGE_MAP(CMyListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CMyListCtrl)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyListCtrl message handlers
void CMyListCtrl::SetStile(DWORD NewStile)
{
	ASSERT(::IsWindow(m_hWnd ));
	DWORD a2 = GetWindowLong(m_hWnd,GWL_STYLE);
	if ((a2 & LVS_TYPEMASK) != NewStile)
		SetWindowLong(m_hWnd, GWL_STYLE , (a2 & ~LVS_TYPEMASK) | NewStile);

}

void CMyListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{

	////////////////////
	//       . LPCTSTR CMyListCtrl::MakeShortString(CDC* pDC, LPCTSTR lpszLong, int nColumnLen, int nOffset)
	//   .
	//        ,     
	//
	//
	////////////////////
__asm
{
	RDTSC
}

	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	CRect rcItem(lpDrawItemStruct->rcItem);
	UINT uiFlags = ILD_TRANSPARENT;

	int nItem = lpDrawItemStruct->itemID;
	BOOL bFocus = (GetFocus() == this);
	COLORREF clrTextSave, clrBkSave;
	COLORREF clrImage = m_clrBkgnd;
//	static _TCHAR szBuff[MAX_PATH];


	

// get item data

	//LV_ITEM lvi;
	//lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	lvi.iItem = nItem;
	//lvi.iSubItem = 0;
	//lvi.pszText = sbuffer;
	//lvi.cchTextMax = sizeof(sbuffer);
	//lvi.stateMask = 0xFFFF;     // get all state flags
	CMyListCtrl::GetItem(&lvi);
	if (CurrentView==0)
	{
			CurrentView=0;
	}

	BOOL bSelected = (bFocus || (GetStyle() & LVS_SHOWSELALWAYS)) && lvi.state & LVIS_SELECTED;
	bSelected = bSelected || (lvi.state & LVIS_DROPHILITED);

// set colors if item is selected

	CRect rcAllLabels;
	CMyListCtrl::GetItemRect(nItem, rcAllLabels, LVIR_BOUNDS);

	CRect rcLabel;
	CMyListCtrl::GetItemRect(nItem, rcLabel, LVIR_LABEL);

///////////////////////////////////////////////////////////////////////
//         
//     ,    
//   
//	


  
		d0=RGB(255,164,26);

	


///////////////////////////////////////////////////////////////////////	

	rcAllLabels.left = rcLabel.left;
	if (m_bClientWidthSel && rcAllLabels.right<m_cxClient)
		rcAllLabels.right = m_cxClient;

	if (bSelected)
	{
		clrTextSave = pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		clrBkSave = pDC->SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));

		pDC->FillRect(rcAllLabels, &CBrush(::GetSysColor(COLOR_HIGHLIGHT)));
	}
	else
	{
///////////////////////////////////////////////////////////////////////	
//	       
			pDC->FillRect(rcLabel, &CBrush(d0));
		
			//		pDC->FillRect(rcAllLabels, &CBrush(m_clrTextBk));
		/* */


	//
	}

///////////////////////////////////////////////////////////////////////	

// set color and mask for the icon


/*
	if (lvi.state & LVIS_CUT)
	{
		clrImage = m_clrBkgnd;
		uiFlags |= ILD_BLEND50;
	}
	else if (bSelected)
	{
		clrImage = ::GetSysColor(COLOR_HIGHLIGHT);
		uiFlags |= ILD_BLEND50;
	}
*/
// draw state icon


// draw normal and overlay icon


// draw item label

	CMyListCtrl::GetItemRect(nItem, rcItem, LVIR_LABEL);
	
	rcItem.right -= m_cxStateImageOffset;



	rcLabel = rcItem;
	rcLabel.left += OFFSET_FIRST;
	rcLabel.right -= OFFSET_FIRST;
///////////////////////////////////////////////////////////////////////	
//    ,     ,    
//	 
///////////////////////////////////////////////////////////////////////	
	//COLORREF oldc=pDC->GetTextColor();
	COLORREF oldc=::GetTextColor(pDC->m_hDC);
	//pDC->SetTextColor(m_clrText);
	::SetTextColor(pDC->m_hDC,m_clrText);

	//pDC->DrawText(&sbuffer[0],-1,rcLabel,DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
	::DrawText(pDC->m_hDC,&sbuffer[0],-1,rcLabel,DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
/////////////////////////////////////////////////////////////////////////	
//	,       
	pDC->SetTextColor(oldc);


// draw labels for extra columns

	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH;

	for(int nColumn = 1; CMyListCtrl::GetColumn(nColumn, &lvc); nColumn++)
	{
		rcItem.left = rcItem.right;
		rcItem.right += lvc.cx;

		//int nRetLen = ;
		if (CMyListCtrl::GetItemText(nItem, nColumn, sbuffer, sizeof(sbuffer)) == 0)
			continue;
		

	
			//rcItem.right - rcItem.left, 2*OFFSET_OTHER;



/*	
			switch(lvc.fmt & LVCFMT_JUSTIFYMASK)
			{
			case LVCFMT_RIGHT:
				nJustify = DT_RIGHT;
				break;
			case LVCFMT_CENTER:
				nJustify = DT_CENTER;
				break;
			default:
				break;
			}
		
*/
		UINT nJustify = DT_LEFT;
		rcLabel = rcItem;
		rcLabel.left += OFFSET_OTHER;
		rcLabel.right -= OFFSET_OTHER;

	//	pDC->DrawText(&sbuffer[0], -1, rcLabel, nJustify | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
	::DrawText(pDC->m_hDC,&sbuffer[0],-1,rcLabel,DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
	}

// draw focus rectangle if item has focus

	if (lvi.state & LVIS_FOCUSED && bFocus)
		pDC->DrawFocusRect(rcAllLabels);

// set original colors if item was selected

	if (bSelected)
	{
		pDC->SetTextColor(clrTextSave);
		pDC->SetBkColor(clrBkSave);
	}

	
//    . 

}

