// diff_traceDlg.cpp : implementation file
//
// Autor: ELF, 2013-2014
// GNU GPL v2
// Project: diif_trace

//// Known bugs: when double compare two logs, out result - link number wrong, difference with real +1. But all addreses - true!
/////	http://exelab.ru/F/index.php?action=vthread&forum=3&topic=20942
///////   See also:  (Tiberium Reversing)-powerful blow from Sony DADC SecuROM. Also tools from SecuROM VM(wow!).
////////     http://exelab.ru/F/index.php?action=vthread&forum=13&topic=19719

#include "stdafx.h"
#include "diff_trace.h"
#include "diff_traceDlg.h"
#include "TL_View.h"
#define IDM_ABOUTBOX                    0x0010

#pragma comment( lib, "comctl32.lib") 
#include <commctrl.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


	

	bool LoadComplete;


bool Valid_saveFile_name;
char buf[64];

#define SC_SYNC_STANDART 0
#define SC_ASYNC_MANUAL 1
#define SC_ASYNC_WITH_EXCEPTIONS 2
#define SC_ASM_STANDART 3

unsigned int Scan_mode;


#define CALC_TRACE_ALL 0
#define CALC_TRACE_1 1
#define CALC_TRACE_2 2

signed int TRACE_CALC_Numb;


char dig_data[16];


unsigned long Check_Strings_Count;

/**/
#define diff_trace__Block "elf_diff_trace"
	#define diff_trace__Block_Verion_Key "Version"

#define diff_trace_CompareFiles_Block "CompareFiles"
	#define diff_trace_CompareFiles_Block_File_1 "File1"
	#define diff_trace_CompareFiles_Block_File_2 "File2"
#define diff_trace_CompareResult_Block "CompareResult"
	#define diff_trace_CompareResult_Block_Count_Key "CountBlockData"
	#define diff_trace_CompareResult_Block_POSITION_1_Key "POSITION_1_"
	#define diff_trace_CompareResult_Block_POSITION_2_Key "POSITION_2_"
	#define diff_trace_CompareResult_Block_ADDRESS_1_Key "ADDRESS_1_"
	#define diff_trace_CompareResult_Block_ADDRESS_2_Key "ADDRESS_2_"
#define diff_trace_Exceptions_Block "Exceptions"
	#define diff_trace_Exceptions_Block_Count_Key "CountBlockData"
	#define diff_trace_Exceptions_Block_Enter_Key "ENTER_"
	#define diff_trace_Exceptions_Block_Exit_1_Key "Exit_1_"
	#define diff_trace_Exceptions_Block_Exit_2_Key "Exit_2_"
	#define diff_trace_Exceptions_Block_Comment_Key "Comment_"
/**/

struct Exception_func_data
{
	char Func_Start_Address[16];
	unsigned int Func_Recurce_DEEP_Count__1;
	unsigned int Func_Recurce_DEEP_Count__2;
	char Func_End_Address_1[16];
	char Func_End_Address_2[16];
	unsigned int Func_Info_Pass_Count;
};


unsigned int Fix_OFFSET_TRACE_VARIANT_1 = 6; //fix 0.73 //+6 bytes from "main" - default for OllyDbg v2.01
unsigned int Fix_OFFSET_TRACE_VARIANT_2 = 6; //fix 0.73 //+6 bytes from "main" - default for OllyDbg v2.01

#define MAX_PASS_FUNC 12

unsigned long Func_Exc_Cur_Point;
Exception_func_data Func_Exc_Global[MAX_PASS_FUNC];

#define MAX_L 255
	// TODO: Add your control notification handler code here
	static char dirstr[MAX_L];
	static char dirstr2[MAX_L];
	
#define diff_trace_STR "0.74"
	CString strFile;





// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };

	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT



}



void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)

		
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




/////////////////////////////////////////////////////////////////////////////
// Cdiff_traceDlg dialog

Cdiff_traceDlg::Cdiff_traceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cdiff_traceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(Cdiff_traceDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cdiff_traceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Cdiff_traceDlg)
	DDX_Control(pDX, IDC_START_ASM_MODE_NORMAL, m_asm_string_mode);
	DDX_Control(pDX, IDC_VIEWER, m_tl_viewer);
	DDX_Control(pDX, IDC_OFFSET_RANGE, m_offset_control);
	DDX_Control(pDX, IDC_SET_ALL, m_calc_set_except_all);
	DDX_Control(pDX, IDC_CALC_RESULT_SHOW, m_calc_except_result_show);
	DDX_Control(pDX, IDC_EXCEPTION_NUMBER, m_calc_except_number);
	DDX_Control(pDX, IDC_LIST3, m_list3);
	DDX_Control(pDX, IDC_NOTE_EXCEPT, m_except_note);
	DDX_Control(pDX, IDC_EXCEPTION, m_control_except);
	DDX_Control(pDX, IDC_LIST2, m_list2);
	DDX_Control(pDX, IDC_EXCEPT_ADDRESS_END1, m_except_end_address_2);
	DDX_Control(pDX, IDC_EXCEPT_ADDRESS_END2, m_except_end_address_1);
	DDX_Control(pDX, IDC_EXCEPT_ADDRESS_START, m_except_start_address);
	DDX_Control(pDX, IDC_LOAD_2_FILES, m_load_control);
	DDX_Control(pDX, IDC_FILE_2_READ, m_lamp_file_read_2);
	DDX_Control(pDX, IDC_FILE_2_MEM_ALLOC, m_lamp_mem_alloc_2);
	DDX_Control(pDX, IDC_FILE_1_READ, m_lamp_read_file_1);
	DDX_Control(pDX, IDC_FILE_1_MEM_ALLOC, m_lamp_mem_alloc_1);
	DDX_Control(pDX, IDC_VALID_FILE_NAME, m_valid_file_name);
	DDX_Control(pDX, IDC_SAVE_FILE_NAME, m_file_String);
	DDX_Control(pDX, IDC_STR_SUB, m_str_sub);
	DDX_Control(pDX, IDC_NUM_SUB, m_sub_string);
	DDX_Control(pDX, IDC_exch, m_exch);
	DDX_Control(pDX, IDC_FILE_2_FOUND, m_lamp_2);
	DDX_Control(pDX, IDC_FILE_1_FOUND, m_lamp_1);
	DDX_Control(pDX, IDC_IDENT, m_ident_dword);
	DDX_Control(pDX, IDC_STR_SECOND, m_str_second);
	DDX_Control(pDX, IDC_STR_ONE, m_str_one);
	DDX_Control(pDX, IDC_NUM_SECOND, m_second_string);
	DDX_Control(pDX, IDC_NUM_ONE, m_one_string);
	DDX_Control(pDX, IDC_START_NO_SYNC, m_sync);
	DDX_Control(pDX, IDC_ENUM_STRING, m_enum_str);
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Control(pDX, IDC_EDIT2, m_file2);
	DDX_Control(pDX, IDC_EDIT1, m_file1);
	DDX_Control(pDX, IDC_BUTTON1, m_action);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(Cdiff_traceDlg, CDialog)
	//{{AFX_MSG_MAP(Cdiff_traceDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnGO)
	ON_BN_CLICKED(IDC_START_NO_SYNC, OnStartNoSync)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, OnRclickList1)
	ON_BN_CLICKED(IDC_exch, Onexch)
	ON_EN_CHANGE(IDC_NUM_ONE, OnChangeNumOne)
	ON_EN_CHANGE(IDC_NUM_SECOND, OnChangeNumSecond)
	ON_BN_CLICKED(IDC_COUNT_CHECK_STRINGS, OnCountCheckStrings)
	ON_BN_CLICKED(IDC_FILE_AUTO_NAME, OnFileAutoName)
	ON_EN_CHANGE(IDC_SAVE_FILE_NAME, OnChangeSaveFileName)
	ON_BN_CLICKED(IDC_LOAD_2_FILES, OnLoad2Files)
	ON_BN_CLICKED(IDC_ADD_EXCEPTION_TO_LIST, OnAddExceptionToList)
	ON_BN_CLICKED(IDC_EXCEPTION, OnException)
	ON_NOTIFY(NM_RCLICK, IDC_LIST2, OnRclickList2)
	ON_NOTIFY(NM_RCLICK, IDC_LIST3, OnRclickList3)
	ON_BN_CLICKED(IDC_CALC_RESULT, OnCalcResult)
	ON_BN_CLICKED(IDC_SET_ALL, OnSetAll)
	ON_BN_CLICKED(IDC_TRACE_NUM_1, OnTRACENum1)
	ON_BN_CLICKED(IDC_TRACE_NUM_2, OnTRACENum2)
	ON_BN_CLICKED(IDC_TRACE_NUM_ALL, OnTRACENumAll)
	ON_BN_CLICKED(IDC_VIEWER, OnViewerTLs)
	ON_BN_CLICKED(IDC_START_ASM_MODE_NORMAL, OnStartAsmModeNormal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cdiff_traceDlg message handlers

BOOL Cdiff_traceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


		GetSystemMenu(FALSE)->AppendMenu(MF_SEPARATOR);
	GetSystemMenu(FALSE)->AppendMenu(MF_STRING, IDM_ABOUTBOX, "A couple of pictures about diff_trace");

		RECT r;
	this->GetWindowRect(&r);
	Scan_mode=SC_SYNC_STANDART;
	::SetWindowPos(m_hWnd, 0, 0, 0, (r.right - r.left)-465, (r.bottom - r.top), SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOMOVE);
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	HINSTANCE HinstMain = GetModuleHandle(NULL);
BMP_TRUE.LoadBitmap(IDB_TRUE);
BMP_FALSE.LoadBitmap(IDB_FALSE);
	// TODO: Add extra initialization here
		//::SetWindowText(m_file1.m_hWnd,"C:\\Documents and Settings\\Administrator\\Desktop\\SecuROM_wrong_disk.txt");
		//::SetWindowText(m_file2.m_hWnd,"C:\\Documents and Settings\\Administrator\\Desktop\\SecuROM_original_disk.txt");

		::SetWindowText(m_file1.m_hWnd,"C:\\Documents and Settings\\Administrator\\Desktop\\false.txt");
		::SetWindowText(m_file2.m_hWnd,"C:\\Documents and Settings\\Administrator\\Desktop\\true.txt");

		::SetWindowText(m_one_string.m_hWnd,"1");
		::SetWindowText(m_second_string.m_hWnd,"7");

m_except_start_address.SetLimitText(8);
m_except_end_address_1.SetLimitText(8);
m_except_end_address_2.SetLimitText(8);

m_list.InsertColumn(0,"Position_1",LVCFMT_LEFT,100);
m_list.InsertColumn(1,"Position_2",LVCFMT_LEFT,100);
m_list.InsertColumn(2,"Address_1",LVCFMT_LEFT,100);
m_list.InsertColumn(3,"Address_2",LVCFMT_LEFT,100);
m_list.InsertColumn(4,"Address separation",LVCFMT_LEFT,100);

m_list2.InsertColumn(0,"Enter",LVCFMT_LEFT,100);
m_list2.InsertColumn(1,"Exit 1",LVCFMT_LEFT,100);
m_list2.InsertColumn(2,"Exit 2",LVCFMT_LEFT,100);
m_list2.InsertColumn(3,"Note",LVCFMT_LEFT,100);

m_list3.InsertColumn(0,"Trace",LVCFMT_LEFT,70);
m_list3.InsertColumn(1,"Exception ",LVCFMT_LEFT,125);
m_list3.InsertColumn(2,"Input",LVCFMT_LEFT,70);
m_list3.InsertColumn(3,"Output",LVCFMT_LEFT,70);
m_list3.InsertColumn(4,"Deep",LVCFMT_LEFT,60);




m_except_end_address_1.SetLimitText(8);
m_calc_except_number.SetLimitText(2);

/* PRIMARY TEST SC_ASYNC_WITH_EXCEPTIONS
m_list2.InsertItem(0,"00DDF462"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,1,"00DDFBFB"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,3,"C++ compare"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS

strcpy(Func_Exc_Global[1].Func_Start_Address,"00DDF462"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[1].Func_End_Address_1,"00DDFBFB"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
//strcpy(Func_Exc_Global[1].Func_End_Address_1,"FFFFFFFF"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS


m_list2.InsertItem(0,"00E2038E"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,1,"00E203C9"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,3,"DISK geometry compare component"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS


strcpy(Func_Exc_Global[2].Func_Start_Address,"00E2038E"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[2].Func_End_Address_1,"00E203C9"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
//strcpy(Func_Exc_Global[2].Func_End_Address_1,"FFFFFFFF"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS

m_list2.InsertItem(0,"00FCB008"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,1,"00FCB07C"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,3,"mDISK geometry cct"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS

strcpy(Func_Exc_Global[3].Func_Start_Address,"00FCB008"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[3].Func_End_Address_1,"00FCB07C"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS


m_list2.InsertItem(0,"00E20312"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,1,"00E2033A"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,2,"00E2033E"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,3,"mDISK ext"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS

strcpy(Func_Exc_Global[4].Func_Start_Address,"00E20312"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[4].Func_End_Address_1,"00E2033E"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[4].Func_End_Address_2,"00E2033A"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS


m_list2.InsertItem(0,"00DDA5C0"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,1,"00DDA722"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
m_list2.SetItemText(0,3,"C++ memcpy"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS

strcpy(Func_Exc_Global[4].Func_Start_Address,"00DDA5C0"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
strcpy(Func_Exc_Global[4].Func_End_Address_1,"00DDA722"); //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS



Func_Exc_Cur_Point = 5; //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS
 END of PRIMARY TEST SC_ASYNC_WITH_EXCEPTIONS */

::SetWindowText(m_except_start_address.m_hWnd,"00DDF462");
::SetWindowText(m_except_end_address_2.m_hWnd,"00DDFBFB");
::SetWindowText(m_except_note.m_hWnd,"C++ compare");



	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cdiff_traceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void Cdiff_traceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	
	CDialog::OnSysCommand(nID, lParam);
		if ((nID) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cdiff_traceDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void Cdiff_traceDlg::OnGO() 
{

m_action.EnableWindow(FALSE);

n1=0;
n2=0;
unsigned int Stroka_1=0;
unsigned int Stroka_2=0;
//unsigned long Address1;
//unsigned long Address2;
//unsigned long Address1_2;
//unsigned long Address2_2;

(DWORD)Pointer1 = (unsigned long)Alloc1;
(DWORD)Pointer2 = (unsigned long)Alloc2;



	switch(Scan_mode)
	{
	case SC_SYNC_STANDART:
		{
			
			Pointer2--;
			do
							{
								if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								n1++;
								//Address1=*(LPDWORD)(Pointer1+6);
								//Address1_2=*(LPDWORD)(Pointer1+10);
											do
											{
												Pointer2++;

												if((Pointer2-(unsigned long)Alloc2)>Fileh2Size)
												{
													return;
												}
											}while(*(LPDWORD)(Pointer2)!=0x6E69616D);

									//Address2=*(LPDWORD)(Pointer2+6);
									//Address2_2=*(LPDWORD)(Pointer2+10);

								
									if(((*(LPDWORD)(Pointer1+6)) != (*(LPDWORD)(Pointer2+6)))||((*(LPDWORD)(Pointer1+10)) != (*(LPDWORD)(Pointer2+10))))
									{
										ltoa(n1,&dig_data[0],10);
										
										m_list.InsertItem(0,&dig_data[0]);
										m_list.SetItemText(0,1,&dig_data[0]);
										//itoa((int)Address2,&dig_data[0],16);
										*(LPDWORD)(Pointer1+14)=NULL;
										m_list.SetItemText(0,2,(LPCSTR)(Pointer1+6));
										*(LPDWORD)(Pointer2+14)=NULL;
										//itoa((int)Address1,&dig_data[0],16);
										m_list.SetItemText(0,3,(LPCSTR)(Pointer2+6));

										unsigned long Copy_Point = Pointer1; //add 0.72 //show last eq address
											if(n1-1 != 0)
											{
												Copy_Point-=10;

												do{
												Copy_Point--;
												}while(*(LPDWORD)(Copy_Point)!=0x6E69616D);
												*(LPDWORD)(Copy_Point+15)=0;
												m_list.SetItemText(0,4,(LPCSTR)(Copy_Point+6));
											}
												n2=n1; //add 0.73 //fix error, when TL_View show trash result in 2nd table
										goto a1;
									}
									
									Pointer2+=38;
									Pointer1+=38;
								}

									
								
								Pointer1++;

							}while(Pointer1-(unsigned long)Alloc1<Fileh1Size);
		}

	break;
	case SC_ASYNC_MANUAL:
	{
		
		::GetWindowText(m_one_string.m_hWnd,&buf[0],32);
		Stroka_1 = atol(&buf[0]);
		::GetWindowText(m_second_string.m_hWnd,&buf[0],32);
		 Stroka_2 = atol(&buf[0]);
		do
		{
				if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								
										if(++n1 >= Stroka_1)
										{
											do
											{
													if(*(LPDWORD)(Pointer2) ==0x6E69616D)
													{
													
														
															if(++n2 >= Stroka_2)
															{
																		if(((*(LPDWORD)(Pointer1+6)) != (*(LPDWORD)(Pointer2+6)))&&((*(LPDWORD)(Pointer1+10)) != (*(LPDWORD)(Pointer2+10))))
																			{
																				ltoa(n1,&dig_data[0],10);
																				m_list.InsertItem(0,&dig_data[0]);
																				ltoa(n2,&dig_data[0],10);
																				m_list.SetItemText(0,1,&dig_data[0]);
																				//itoa((int)Address2,&dig_data[0],16);
																				*(LPDWORD)(Pointer1+14)=NULL;
																				m_list.SetItemText(0,2,(LPCSTR)(Pointer1+6));
																				*(LPDWORD)(Pointer2+14)=NULL;
																				//itoa((int)Address1,&dig_data[0],16);
																				m_list.SetItemText(0,3,(LPCSTR)(Pointer2+6));

																					unsigned long Copy_Point = Pointer1; //add 0.72 //show last eq address
																							if(n1-1 != 0)
																							{
																								Copy_Point-=10;

																								do{
																								Copy_Point--;
																								}while(*(LPDWORD)(Copy_Point)!=0x6E69616D);
																								*(LPDWORD)(Copy_Point+15)=0;
																								m_list.SetItemText(0,4,(LPCSTR)(Copy_Point+6));
																							}

																				goto a1;
																			}
																Pointer1+=38;
																Pointer2+=38;
																break;
															}
													}
													
												Pointer2++;
											}while((Pointer2-(unsigned long)Alloc2<Fileh2Size));

										}
								}
				Pointer1++;

		}
		while((Pointer1-(unsigned long)Alloc1<Fileh1Size));
	
	}
	break;	
	case SC_ASYNC_WITH_EXCEPTIONS:
		unsigned int __LOCK_GLOBAL_EXC_DEEP__1=0;
		unsigned int __LOCK_GLOBAL_EXC_DEEP__2=0;
		{
			if(m_sync.GetState())
			{
				::GetWindowText(m_one_string.m_hWnd,&buf[0],32);
					Stroka_1 = atoi(&buf[0]);
					::GetWindowText(m_second_string.m_hWnd,&buf[0],32);
						Stroka_2 = atoi(&buf[0]);
			}

				do
					{
					if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								
										if(n1++ == Stroka_1)
										{
											do
											{
													if(*(LPDWORD)(Pointer2) ==0x6E69616D)
													{
													
														
															if(n2++ == Stroka_2)
															{
																
																		goto Continue_3;
															
															}
													}
													
												Pointer2++;
											}while((Pointer2-(unsigned long)Alloc2<Fileh2Size));

										}

								}
					Pointer1++;
					}while((Pointer1-(unsigned long)Alloc1<Fileh1Size));
					
					return;
					Continue_3: ///////////////////////////////////////////[ EXCEPT HERE ]///////////////////////////////////////////////////////////////////////////////////////////
				
					do
					{
					if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								//	if((__LOCK_GLOBAL_EXC_DEEP__1 == __LOCK_GLOBAL_EXC_DEEP__2)&&((__LOCK_GLOBAL_EXC_DEEP__2 == NULL)))
								//						{
								//						n1++;
								//						}
						
					
											do
											{
													if(*(LPDWORD)(Pointer2) ==0x6E69616D)
													{
														//		if((__LOCK_GLOBAL_EXC_DEEP__1 == __LOCK_GLOBAL_EXC_DEEP__2)&&((__LOCK_GLOBAL_EXC_DEEP__1 == NULL)))
														//								{
														//							
														//								}
															
															for(unsigned int i=Func_Exc_Cur_Point;i>0; --i)
															{
																	/// START CHECK 1ST STREAM
																if(!memcmp(Func_Exc_Global[i].Func_Start_Address,(LPDWORD)(Pointer1+6),8))
																{
																		Func_Exc_Global[i].Func_Recurce_DEEP_Count__1++;
																		__LOCK_GLOBAL_EXC_DEEP__1++;


																		m_list3.InsertItem(0,"1");
																		my_xtoa_10(i);
																		m_list3.SetItemText(0,1,&dig_data[0]);
																		my_xtoa_10(n1); //ltoa(n1,&dig_data[0],10);
																		m_list3.SetItemText(0,2,&dig_data[0]);
																		my_xtoa_10(Func_Exc_Global[i].Func_Recurce_DEEP_Count__1);
																		m_list3.SetItemText(0,4,&dig_data[0]);
																	

																//	::SendMessage(m_list3.m_hWnd,LVM_SETITEM,NULL,(LONG)&dig_data[0]);
																	
																		
																}
																else
																{
																	if(Func_Exc_Global[i].Func_Recurce_DEEP_Count__1 != NULL)
																		{
																					if((!memcmp(Func_Exc_Global[i].Func_End_Address_1,(LPDWORD)(Pointer1+6),8))||(!memcmp(Func_Exc_Global[i].Func_End_Address_2,(LPDWORD)(Pointer1+6),8)))
																						{
																						
																						Func_Exc_Global[i].Func_Recurce_DEEP_Count__1--;
																						__LOCK_GLOBAL_EXC_DEEP__1--;
																						

																					
																						
																						}	
																		
																		}
																	
																																		
																}
																/* END CHECK 1ST STREAM*/
																	
																/// START CHECK 2ST STREAM						
																if(!memcmp(Func_Exc_Global[i].Func_Start_Address,(LPDWORD)(Pointer2+6),8))
																								{
																							Func_Exc_Global[i].Func_Recurce_DEEP_Count__2++;
																							__LOCK_GLOBAL_EXC_DEEP__2++;

																										m_list3.InsertItem(0,"2");
																										my_xtoa_10(i);
																										m_list3.SetItemText(0,1,&dig_data[0]);
																										my_xtoa_10(n2); //ltoa(n1,&dig_data[0],10);
																										m_list3.SetItemText(0,2,&dig_data[0]);
																										my_xtoa_10(Func_Exc_Global[i].Func_Recurce_DEEP_Count__2);
																										m_list3.SetItemText(0,4,&dig_data[0]);
																								}
																								else
																								{
																									if(Func_Exc_Global[i].Func_Recurce_DEEP_Count__2 != NULL)
																									{
																										if((!memcmp(Func_Exc_Global[i].Func_End_Address_1,(LPDWORD)(Pointer2+6),8))||(!memcmp(Func_Exc_Global[i].Func_End_Address_2,(LPDWORD)(Pointer2+6),8)))
																											{
																												Func_Exc_Global[i].Func_Recurce_DEEP_Count__2--;
																														if((--__LOCK_GLOBAL_EXC_DEEP__2 == 0)&&(__LOCK_GLOBAL_EXC_DEEP__1)==0) //fix error when two traces have non equal exits // parallel jump in next strings
																															{

																															Pointer2+=20;
																															n2++;
																															Pointer1+=20;
																															n1++;

																															goto skip_main_check;
																															
																															}

																												
																											}	
																		
																									}
																								}
																/* END CHECK 2ST STREAM*/
																	
															}// END CYCLE

																// MAIN COMPARE IF
																if((__LOCK_GLOBAL_EXC_DEEP__2 + __LOCK_GLOBAL_EXC_DEEP__1) == NULL)
																{
																		if(((*(LPDWORD)(Pointer1+6)) != (*(LPDWORD)(Pointer2+6)))||((*(LPDWORD)(Pointer1+10)) != (*(LPDWORD)(Pointer2+10))))
																	//	if(memcmp((LPDWORD)(Pointer1+6),((LPDWORD)(Pointer2+6)),2))
																			{
																				ltoa(n1,&dig_data[0],10);
																				m_list.InsertItem(0,&dig_data[0]);
																				ltoa(n2,&dig_data[0],10);
																				m_list.SetItemText(0,1,&dig_data[0]);
																				//itoa((int)Address2,&dig_data[0],16);
																				*(LPDWORD)(Pointer1+14)=NULL;
																				m_list.SetItemText(0,2,(LPCSTR)(Pointer1+6));
																				*(LPDWORD)(Pointer2+14)=NULL;
																				//itoa((int)Address1,&dig_data[0],16);
																				m_list.SetItemText(0,3,(LPCSTR)(Pointer2+6));

																								unsigned long Copy_Point = Pointer1; //add 0.72 //show last eq address
																							if(n1-1 != 0)
																							{
																								Copy_Point-=10;

																								do{
																								Copy_Point--;
																								}while(*(LPDWORD)(Copy_Point)!=0x6E69616D);
																								*(LPDWORD)(Copy_Point+15)=0;
																								m_list.SetItemText(0,4,(LPCSTR)(Copy_Point+6));
																							}
																				goto a1;
																			}
																}
																/* END MAIN COMPARE IF*/
	

																			//if((__LOCK_GLOBAL_EXC_DEEP__2 == NULL)||((__LOCK_GLOBAL_EXC_DEEP__1 != NULL)&&((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))))
																	//		if((__LOCK_GLOBAL_EXC_DEEP__2 == __LOCK_GLOBAL_EXC_DEEP__1)||(__LOCK_GLOBAL_EXC_DEEP__2 != NULL))
																	//		{
																	//			Pointer1+=20;
																	//			n1++;
																	//		}
																			//if((__LOCK_GLOBAL_EXC_DEEP__1 == NULL)||((__LOCK_GLOBAL_EXC_DEEP__1 != NULL)&&((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))))
																	//		if((__LOCK_GLOBAL_EXC_DEEP__2 == __LOCK_GLOBAL_EXC_DEEP__1)||(__LOCK_GLOBAL_EXC_DEEP__1 != NULL))
																	//		{
																	//			Pointer2+=20;
																	//			n2++;
																	//		}


																
																		if(((__LOCK_GLOBAL_EXC_DEEP__1 != NULL))&&(__LOCK_GLOBAL_EXC_DEEP__2 == NULL))
																		{
																
																		}
																	else
																		{
																				Pointer2+=38;
																						n2++;
																		}

																			if(((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))&&(__LOCK_GLOBAL_EXC_DEEP__1 == NULL))
																					{
																					
																					}
																			else
																					{
																						Pointer1+=38;
																						n1++;
																					}
								skip_main_check:	
															break;
																	
																				
																
																		
															
													}

												/*	if((__LOCK_GLOBAL_EXC_DEEP__1 == NULL)||((__LOCK_GLOBAL_EXC_DEEP__1 != NULL)&&((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))))
													if((__LOCK_GLOBAL_EXC_DEEP__1 == __LOCK_GLOBAL_EXC_DEEP__2)||((__LOCK_GLOBAL_EXC_DEEP__1 == NULL)))
													{
													Pointer2++;	
													}
												
													else
													{
														
														break;
													}
													*/
															if(((__LOCK_GLOBAL_EXC_DEEP__1 != NULL))&&(__LOCK_GLOBAL_EXC_DEEP__2 == NULL))
																{
																
																}
																	else
																{
																	Pointer2++;	
																}

											}while((Pointer2-(unsigned long)Alloc2<Fileh2Size));
											
									
									
								}
						//if((__LOCK_GLOBAL_EXC_DEEP__2 == NULL)||((__LOCK_GLOBAL_EXC_DEEP__1 != NULL)&&((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))))
					//	if((__LOCK_GLOBAL_EXC_DEEP__1 == __LOCK_GLOBAL_EXC_DEEP__2)||((__LOCK_GLOBAL_EXC_DEEP__2 == NULL)))
					if(((__LOCK_GLOBAL_EXC_DEEP__2 != NULL))&&(__LOCK_GLOBAL_EXC_DEEP__1 == NULL))
							{
							
							}
					else
							{
								Pointer1++;	
							}
					if((Pointer2-(unsigned long)Alloc2>=Fileh2Size))
					{
						break;
					}

					}while((Pointer1-(unsigned long)Alloc1<Fileh1Size));
					break;
		}

		case SC_ASM_STANDART: //add 0.74
					{
						n1=0;
						
						__asm
						{
							RDTSC
						}
						
			
			Pointer2--;
							do
							{
								if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								n1++;
						
											do
											{
												Pointer2++;

												if((Pointer2-(unsigned long)Alloc2)>Fileh2Size)
												{
													return;
												}
											}while(*(LPDWORD)(Pointer2)!=0x6E69616D);

									DWORD ASM_Pointer1=Pointer1+34;
									DWORD ASM_Pointer2=Pointer2+34;
									do
									{
										if (memcmp((const void*)ASM_Pointer1,(const void*)ASM_Pointer2,1)!=0)
										{
											ltoa(n1,&dig_data[0],10);

										m_list.InsertItem(0,&dig_data[0]);
										
										m_list.SetItemText(0,1,&dig_data[0]);
										//itoa((int)Address2,&dig_data[0],16);
										*(LPDWORD)(Pointer1+14)=NULL;
										m_list.SetItemText(0,2,(LPCSTR)(Pointer1+6));
										*(LPDWORD)(Pointer2+14)=NULL;
										//itoa((int)Address1,&dig_data[0],16);
										m_list.SetItemText(0,3,(LPCSTR)(Pointer2+6));

										unsigned long Copy_Point = Pointer1; //add 0.72 //show last eq address
											if(n1-1 != 0)
											{
												Copy_Point-=10;

												do{
												Copy_Point--;
												}while(*(LPDWORD)(Copy_Point)!=0x6E69616D);
												*(LPDWORD)(Copy_Point+15)=0;
												m_list.SetItemText(0,4,(LPCSTR)(Copy_Point+6));
											}
												n2=n1; //add 0.73 //fix error, when TL_View show trash result in 2nd table
											goto a1;
											
										}

										if(*(LPWORD)ASM_Pointer1==0x0A0D)
										{
											break;
										}
									
									++ASM_Pointer2;
									}while(*(LPDWORD)++ASM_Pointer1!=0x20202020);
									
						
									
									Pointer2+=38;
									Pointer1+=38;
								}

								Pointer1++;
							}while(Pointer1-(unsigned long)Alloc1<Fileh1Size);
						}

			break;
}

		




a1:
	//	VirtualFreeEx((HANDLE)-1,Alloc1,Fileh1Size,MEM_DECOMMIT);
	//	VirtualFreeEx((HANDLE)-1,Alloc2,Fileh2Size,MEM_DECOMMIT);
			
			Check_Strings_Count+= (n1-Stroka_1)+1;
			ltoa((int)Check_Strings_Count,&dig_data[0],10);

		::SetWindowText(m_enum_str.m_hWnd,&dig_data[0]);
m_action.EnableWindow(TRUE);
}

void Cdiff_traceDlg::OnStartNoSync() 
{
	// TODO: Add your control notification handler code here

	if (m_sync.GetCheck())
	{

			if(Scan_mode!=SC_ASYNC_WITH_EXCEPTIONS)
		{
		Scan_mode=SC_ASYNC_MANUAL;
		}

		
		m_str_one.EnableWindow(true);
		m_str_second.EnableWindow(true);
		m_one_string.EnableWindow(true);
		m_second_string.EnableWindow(true);
		m_sub_string.EnableWindow(true);
		m_str_sub.EnableWindow(true);
		m_asm_string_mode.EnableWindow(false);
	}
	else
	{
				if(Scan_mode!=SC_ASYNC_WITH_EXCEPTIONS)
		{
		Scan_mode=SC_SYNC_STANDART;
		}

	
		m_str_one.EnableWindow(false);
		m_str_second.EnableWindow(false);
		m_one_string.EnableWindow(false);
		m_second_string.EnableWindow(false);
		m_sub_string.EnableWindow(false);
		m_str_sub.EnableWindow(false);
		m_asm_string_mode.EnableWindow(true);
	}

	
}


void Cdiff_traceDlg::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	::GetWindowText(m_file1.m_hWnd,&dirstr[0],555);
	if (::GetFileAttributes(&dirstr[0]) == -1)
	{
		m_lamp_1.SetBitmap(BMP_FALSE);
	}
	else
	{
		m_lamp_1.SetBitmap(BMP_TRUE);
	}
	//::GetWindowText(m_file2.m_hWnd,&dirstr2[0],555);

	
}

void Cdiff_traceDlg::OnChangeEdit2() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		::GetWindowText(m_file2.m_hWnd,&dirstr[0],555);
	if (::GetFileAttributes(&dirstr[0]) == -1)
	{
		m_lamp_2.SetBitmap(BMP_FALSE);
	}
	else
	{
		m_lamp_2.SetBitmap(BMP_TRUE);
	}
}

void Cdiff_traceDlg::OnRclickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	static CMenu pMny;

	POSITION a = m_list.GetFirstSelectedItemPosition();
		if((int)a==NULL)
		{
		return;
		}
	a--;
	CPoint pt;
	GetCursorPos(&pt);

	pMny.CreatePopupMenu();
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x1, "&Copy position 1");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x2, "&Copy position 2");
	pMny.AppendMenu(MF_SEPARATOR, 0xFF, "");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x3, "&Copy address 1");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x4, "&Copy address 2");
	pMny.AppendMenu(MF_SEPARATOR, 0xFF, "");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x5, "Remove &all items"); 
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x6, "Removing &duplicate items");
	pMny.AppendMenu(MF_SEPARATOR, 0xFF, "");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x7, "Save results to &file");

	unsigned int b = (unsigned int)TrackPopupMenuEx(pMny,TPM_LEFTALIGN|TPM_RETURNCMD,pt.x,pt.y,m_hWnd,NULL);

		switch(b)
		{
		case 1:
		case 2:
		case 3:
		case 4:
			{
				HGLOBAL GAll = GlobalAlloc(GMEM_MOVEABLE,20);
				LPVOID GTxt;
					if(GAll != NULL)
					{
						GTxt = GlobalLock(GAll);
						m_list.GetItemText((unsigned int)a,--b,(LPSTR)GTxt,19);
						GlobalUnlock(GAll);

								OpenClipboard();
								EmptyClipboard();
						SetClipboardData(CF_TEXT,GTxt);
							CloseClipboard();
							
					
					}
				GlobalFree(GAll);
		break;
			}
		case 5:
			{
				m_list.DeleteAllItems();
				break;
			}
		case 6:
			{
				int C = m_list.GetItemCount();

				if(C>1)
				{
					do{
					int D = C;
					
					do
					{
					m_list.GetItemText(C,1,&dirstr[0],24);
					m_list.GetItemText(D,1,&dirstr2[0],24);
					if(D==C)
					{
						D--;
					}
							if (!strcmp(&dirstr[0],&dirstr2[0]))
							{
								m_list.DeleteItem(D);
								C--;
							}
					
					}while(--D>=0);
					}while(--C>0);
				}
		
			}

			case 7:
			{



				if(Valid_saveFile_name)
				{
				::GetWindowText(m_file_String.m_hWnd,&dirstr[0],555);	
				Save_profile_ops(&dirstr[0]);
				
				}
				else
				{
						CFileDialog DlgSave(false,(LPCSTR)"ini",NULL, OFN_HIDEREADONLY,(LPCSTR)" Text Files (*.ini) |*.ini||");

						
							if(DlgSave.DoModal()==IDOK)
							{
							strFile = DlgSave.GetPathName();
							Save_profile_ops(strFile.GetBuffer(0));
							}

				DlgSave.DestroyWindow();
				}
			}


		}
		::DestroyMenu(pMny.m_hMenu);
	*pResult = 0;
}

void Cdiff_traceDlg::Onexch() 
{
	// TODO: Add your control notification handler code here
	::GetWindowText(m_one_string.m_hWnd,&dirstr[0],555);
		::GetWindowText(m_second_string.m_hWnd,&dirstr2[0],555);
		
		::SetWindowText(m_second_string.m_hWnd,&dirstr[0]);
	::SetWindowText(m_one_string.m_hWnd,&dirstr2[0]);
	
		
}

void Cdiff_traceDlg::OnChangeNumOne() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
			if(::GetWindowText(m_second_string.m_hWnd,&buf[0],32) == NULL)
		{
			return;
		}
	signed long Change_1 = atol(&buf[0]);
	if (::GetWindowText(m_one_string.m_hWnd,&buf[0],32) ==NULL)
	{
		return;
	}
		signed long Change_2 = atol(&buf[0]);
		Change_1=Change_1-Change_2;
		if(Change_1<0)
		{
			Change_1 = ~Change_1+1;
		}
		ltoa(Change_1,&buf[0],10);
		::SetWindowText(m_sub_string.m_hWnd,&buf[0]);
	
}

void Cdiff_traceDlg::OnChangeNumSecond() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		if(::GetWindowText(m_second_string.m_hWnd,&buf[0],32) == NULL)
		{
			return;
		}
	signed int Change_1 = atoi(&buf[0]);
	if (::GetWindowText(m_one_string.m_hWnd,&buf[0],32) ==NULL)
	{
		return;
	}
		signed int Change_2 = atoi(&buf[0]);
		Change_1=Change_1-Change_2;
		if(Change_1<0)
		{
			Change_1 = ~Change_1+1;
		}
		ltoa(Change_1,&buf[0],10);
		::SetWindowText(m_sub_string.m_hWnd,&buf[0]);
}

void Cdiff_traceDlg::OnCountCheckStrings() 
{
	// TODO: Add your control notification handler code here
	Check_Strings_Count=NULL;
	::SetWindowText(m_enum_str.m_hWnd,"");
}



void Cdiff_traceDlg::OnFileAutoName() 
{
	
	// TODO: Add your control notification handler code here


		::GetWindowText(m_file2.m_hWnd,&dirstr[0],555);
		if (::GetFileAttributes(&dirstr[0]) != -1)
			{
			::GetWindowText(m_file1.m_hWnd,&dirstr[0],555);
					if (::GetFileAttributes(&dirstr[0]) != -1)
					{
						_splitpath(&dirstr[0],&dirstr2[0],&dirstr2[2],&dirstr2[300],&dirstr2[450]);

						int end_str = strlen(&dirstr2[0]);

						strcpy(&dirstr2[end_str],"diff_trace_data_");
						end_str+=15;
						for(DWORD i=0;i<ULONG_MAX;i++)
						{
							itoa(i,&buf[0],10);

							int end_str_2 = strlen(&buf[0]);

							strcpy(&dirstr2[end_str],&buf[0]);
							end_str += end_str_2;
							strcpy(&dirstr2[end_str],".ini");
							if (::GetFileAttributes(&dirstr2[0]) == -1)
							{
								::SetWindowText(m_file_String.m_hWnd,&dirstr2[0]);
								return;
							}

						}

					}
			}
	

		
}

void Cdiff_traceDlg::OnChangeSaveFileName() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	::GetWindowText(m_file_String.m_hWnd,&dirstr[0],555);
					if (::GetFileAttributes(&dirstr[0]) == -1)
					{
						_splitpath(&dirstr[0],&dirstr2[0],&dirstr2[2],&dirstr2[300],&dirstr2[450]);
							if (::GetFileAttributes(&dirstr2[0]) == -1)
									{
										m_valid_file_name.SetBitmap(BMP_FALSE);
										Valid_saveFile_name=false;
										return;
									}
						m_valid_file_name.SetBitmap(BMP_TRUE);
						Valid_saveFile_name=true;
					}
					else
					{
						m_valid_file_name.SetBitmap(BMP_FALSE);
						Valid_saveFile_name=false;
					}

	
}

void Cdiff_traceDlg::OnLoad2Files() 
{
	// TODO: Add your control notification handler code here

		::GetWindowText(m_file1.m_hWnd,&dirstr[0],555);
	::GetWindowText(m_file2.m_hWnd,&dirstr2[0],555);
	_splitpath(&dirstr[0],NULL,NULL,&name_file1[0],NULL);
	_splitpath(&dirstr2[0],NULL,NULL,&name_file2[0],NULL);

				//m_load_lamp_2.SetBitmap(BMP_FALSE);
	if(LoadComplete)
	{
		::VirtualFree(Alloc2,Fileh2Size,MEM_DECOMMIT);
		::VirtualFree(Alloc1,Fileh1Size,MEM_DECOMMIT);
	m_lamp_read_file_1.SetBitmap(BMP_FALSE);
	m_lamp_file_read_2.SetBitmap(BMP_FALSE);
	m_lamp_mem_alloc_1.SetBitmap(BMP_FALSE);
	m_lamp_mem_alloc_2.SetBitmap(BMP_FALSE);
	::SetWindowText(m_load_control.m_hWnd,"&Load trace logs");
	m_action.EnableWindow(false);
	m_tl_viewer.EnableWindow(false);
	LoadComplete=false;
	n1=0;
	n2=0;
	}
	else
	{
	LoadComplete=true;
	

	m_lamp_read_file_1.SetBitmap(BMP_TRUE);
	m_lamp_file_read_2.SetBitmap(BMP_TRUE);
	m_lamp_mem_alloc_1.SetBitmap(BMP_TRUE);
	m_lamp_mem_alloc_2.SetBitmap(BMP_TRUE);

	HANDLE Fileh1 = CreateFile(&dirstr[0],GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (Fileh1 == INVALID_HANDLE_VALUE)
	{
		
	
	}

	HANDLE Fileh2 = CreateFile(&dirstr2[0],GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (Fileh2 == INVALID_HANDLE_VALUE)
	{
	//goto error2;

	}

		if((Fileh1 == INVALID_HANDLE_VALUE)||(Fileh1 == INVALID_HANDLE_VALUE))
		{

			CloseHandle(Fileh1);
			CloseHandle(Fileh2);
				m_lamp_read_file_1.SetBitmap(BMP_FALSE);
				m_lamp_file_read_2.SetBitmap(BMP_FALSE);
				m_lamp_mem_alloc_1.SetBitmap(BMP_FALSE);
				m_lamp_mem_alloc_2.SetBitmap(BMP_FALSE);
				return;
		}
		

	Fileh1Size = GetFileSize(Fileh1,NULL);
	Fileh2Size = GetFileSize(Fileh2,NULL);
	Fileh1Size = 60000000;
	Fileh2Size = Fileh1Size;

	/* cutting biggest file */
	unsigned long FileAddrRange; //fix 0.72 //fix error when VirtualAlloc cannot allocate req mem size for biggest file
	if(Fileh1Size > Fileh2Size)
	{	
		FileAddrRange = Fileh1Size - Fileh2Size;
		if(FileAddrRange>((Fileh2Size)/2))
		{
		Fileh1Size = Fileh2Size;
		}
	}
	else
	{
		FileAddrRange = Fileh2Size - Fileh1Size;
		if(FileAddrRange>((Fileh1Size)/2))
		{
		Fileh2Size = Fileh1Size;
		}
	}
	
		

	Alloc1 = ::VirtualAllocEx((HANDLE)-1,NULL,Fileh1Size,MEM_COMMIT|MEM_RESERVE,PAGE_READWRITE);
	if(Alloc1 ==NULL)
	{
		m_lamp_mem_alloc_1.SetBitmap(BMP_FALSE);
	
	}



	 

	 Alloc2 =::VirtualAllocEx((HANDLE)-1,NULL,Fileh2Size,MEM_COMMIT|MEM_RESERVE,PAGE_READWRITE);
			if(Alloc2 ==NULL)
			{
		m_lamp_mem_alloc_2.SetBitmap(BMP_FALSE);
			}
			else
			{
		
		m_lamp_mem_alloc_2.SetBitmap(BMP_TRUE);
			}

	SetFilePointer(Fileh1,0,NULL,FILE_BEGIN);
	DWORD NumByRead;
	
			if (ReadFile(Fileh1,Alloc1,Fileh1Size,&NumByRead,NULL) !=1)
			{
				LoadComplete=false;
				if(Alloc1 !=NULL)
					{
				::VirtualFree(Alloc1,Fileh1Size,MEM_DECOMMIT);
					}


				m_lamp_read_file_1.SetBitmap(BMP_FALSE);
		
			}
			


SetFilePointer(Fileh2,0,NULL,FILE_BEGIN);

			if (ReadFile(Fileh2,Alloc2,Fileh2Size,&NumByRead,NULL) !=1)
			{
			//MessageBoxEx(NULL,_T("    2!"),_T("diff_trace: "),MB_OK|MB_ICONASTERISK,NULL);

				m_lamp_file_read_2.SetBitmap(BMP_FALSE);
			LoadComplete=false;

					if(Alloc2 !=NULL)
					{
				::VirtualFree(Alloc2,Fileh2Size,MEM_DECOMMIT);
					}
							if(Alloc1 !=NULL)
					{
				::VirtualFree(Alloc1,Fileh1Size,MEM_DECOMMIT);
					}

			}

			CloseHandle(Fileh2);
			CloseHandle(Fileh1);

			if(LoadComplete)
			{
				::SetWindowText(m_load_control.m_hWnd,"&Unload");
				m_action.EnableWindow(true);
				m_tl_viewer.EnableWindow(true);
				n1=0;
				n2=0;
					Pointer1=reinterpret_cast<DWORD>(Alloc1);
					Pointer2=reinterpret_cast<DWORD>(Alloc2);
				
			}

	}

	
}

void Cdiff_traceDlg::OnAddExceptionToList() 
{
	// TODO: Add your control notification handler code here
	::GetWindowText(m_except_start_address.m_hWnd,&dirstr[0],9);
	::GetWindowText(m_except_end_address_2.m_hWnd,&dirstr2[0],9);
	if((strlen(&dirstr[0]) == NULL)||(strlen(&dirstr2[0]) == NULL))
		{
		return;
		}
	m_list2.InsertItem(0,&dirstr[0]);
	m_list2.SetItemText(0,1,&dirstr2[0]);

	Func_Exc_Cur_Point++; //0 -n/a

	strcpy(&Func_Exc_Global[Func_Exc_Cur_Point].Func_Start_Address[0],&dirstr[0]);
	strcpy(&Func_Exc_Global[Func_Exc_Cur_Point].Func_End_Address_1[0],&dirstr2[0]);
	Func_Exc_Global[Func_Exc_Cur_Point].Func_End_Address_2[0] = '\0';
	

	::GetWindowText(m_except_end_address_1.m_hWnd,&dirstr[0],9);
		if((strlen(&dirstr[0]) != NULL))
		{
			if (atol(&dirstr[0]) !=NULL)
				{
			strcpy(&Func_Exc_Global[Func_Exc_Cur_Point].Func_End_Address_2[0],&dirstr[0]);
			m_list2.SetItemText(0,2,&dirstr[0]);
				}
		}
		Scan_mode=SC_ASYNC_WITH_EXCEPTIONS;

	::GetWindowText(m_except_note.m_hWnd,&dirstr2[0],32);
	if((strlen(&dirstr2[0]) == NULL))
		{
		return;
		}
	
		m_list2.SetItemText(0,3,&dirstr2[0]);
}

void Cdiff_traceDlg::OnException() 
{
	// TODO: Add your control notification handler code here



	RECT r;
	this->GetWindowRect(&r);
	switch(Scan_mode)
	{
	case SC_ASM_STANDART:
	case SC_SYNC_STANDART:
		
	case SC_ASYNC_MANUAL:
		{
			::SetWindowPos(m_hWnd, 0, 0, 0, (r.right - r.left)+465, (r.bottom - r.top), SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOMOVE);
			if(m_list.GetItemCount != NULL)
			{
				Scan_mode=SC_ASYNC_WITH_EXCEPTIONS;
			}

		break;
		}
	case SC_ASYNC_WITH_EXCEPTIONS:
		{
			::SetWindowPos(m_hWnd, 0, 0, 0, (r.right - r.left)-465, (r.bottom - r.top), SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOMOVE);
				if (m_sync.GetCheck())
					{
					Scan_mode=SC_ASYNC_MANUAL;
					}
				else
					{
					Scan_mode=SC_SYNC_STANDART;
					}


		}
	}
	::InvalidateRect(m_hWnd, 0, TRUE);
	//Scan_mode=SC_ASYNC_WITH_EXCEPTIONS; //STRING FROM TEST - SC_ASYNC_WITH_EXCEPTIONS !!!!!!!!!!!!!!!!!
	
}

	

void Cdiff_traceDlg::OnRclickList2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
		static CMenu pMny;

	POSITION a = m_list2.GetFirstSelectedItemPosition();
		if((int)a==NULL)
		{
		return;
		}
	a--;
	CPoint pt;
	GetCursorPos(&pt);

	pMny.CreatePopupMenu();
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x1, "&Remove current position");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x2, "Remove &all");
	pMny.AppendMenu(MF_SEPARATOR, 0xFF, "");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x3, "Removing &duplicate items");



	unsigned int b = (unsigned int)TrackPopupMenuEx(pMny,TPM_LEFTALIGN|TPM_RETURNCMD,pt.x,pt.y,m_hWnd,NULL);

		switch(b)
		{
		case 1:
			{

				m_list2.DeleteItem((int)a);
			
				break;
			}
		case 2:
			{
				m_list2.DeleteAllItems();
				break;
			}
		case 3:
			{
				int C = m_list2.GetItemCount();

				if(C>1)
				{
					do{
					int D = C;
					
					do
					{
					m_list2.GetItemText(C,0,&dirstr[0],24);
					m_list2.GetItemText(D,0,&dirstr2[0],24);
					if(D==C)
					{
						D--;
						continue;	
					}
				
							if (!strcmp(&dirstr[0],&dirstr2[0]))
							{
								m_list2.DeleteItem(D);
								C--;
							}
					
					
					}while(--D>=0);
					}while(--C>0);
				}
		
			}




		}
		::DestroyMenu(pMny.m_hMenu);
	*pResult = 0;
}


void __fastcall  Cdiff_traceDlg::my_xtoa_10 (unsigned long val)
{
//	ltoa(n1,&dig_data[0],10);

        static char *p;                /* pointer to traverse string */
        static char *firstdig;         /* pointer to first digit */
       static char temp;              /* temp char */
 static unsigned digval;        /* value of digit */
//RADIX = 10
        p = &dig_data[0];

      /*  if (is_neg) {
       
            *p++ = '-';
            val = (unsigned long)(-(long)val);
        }*/

        firstdig = &dig_data[0];          /* save pointer to first digit */

        do {
            digval = (unsigned) (val % 10);
            val /= 10;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

void Cdiff_traceDlg::OnRclickList3(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
		static CMenu pMny;

	POSITION a = m_list3.GetFirstSelectedItemPosition();
		if((int)a==NULL)
		{
		return;
		}
	a--;
	CPoint pt;
	GetCursorPos(&pt);


	pMny.CreatePopupMenu();
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x1, "&Remove current position");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x2, "Remove &all");
	pMny.AppendMenu(MF_SEPARATOR, 0xFF, "");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x3, "Count the total number of exemptions in tracer 1");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x4, "Count the total number of exemptions in tracer 2");
	pMny.AppendMenu(MF_STRING|MF_POPUP, 0x5, "Total records");


	int l3c = m_list3.GetItemCount();
	int Count_Calc=0;

	unsigned int b = (unsigned int)TrackPopupMenuEx(pMny,TPM_LEFTALIGN|TPM_RETURNCMD,pt.x,pt.y,m_hWnd,NULL);
	
		switch(b)
		{
		case 1:
			{

				m_list3.DeleteItem((int)a);
			
				break;
			}
		case 2:
			{
				m_list3.DeleteAllItems();
				break;
			}
		case 3:
			{
				
			
											for(l3c;l3c>0;--l3c)
											{
												m_list3.GetItemText(l3c-1,0,&dig_data[0],8);

												if(atoi(&dig_data[0])==1)
												{
													
															Count_Calc++;
														
												}
											
											}
					itoa(Count_Calc,&dig_data[0],10);
					::SetWindowText(m_calc_except_result_show.m_hWnd,&dig_data[0]);

				break;
			}
		case 4:
			{
			
						for(l3c;l3c>0;--l3c)
											{
												m_list3.GetItemText(l3c-1,0,&dig_data[0],8);
													
											

												if(atoi(&dig_data[0])==2)
												{
													
															Count_Calc++;
														
												}
											
											}
					itoa(Count_Calc,&dig_data[0],10);
					::SetWindowText(m_calc_except_result_show.m_hWnd,&dig_data[0]);

				break;
			}
		case 5:
			{
				itoa(l3c,&dig_data[0],10);
				::SetWindowText(m_calc_except_result_show.m_hWnd,&dig_data[0]);

				break;
			}
		




		}
		::DestroyMenu(pMny.m_hMenu);
		


	*pResult = 0;
}

void Cdiff_traceDlg::OnCalcResult() 
{
	// TODO: Add your control notification handler code here
		int l3c = m_list3.GetItemCount();

		if(l3c==0)
		{
			::SetWindowText(m_calc_except_result_show.m_hWnd,"");
				return;
		}
			UINT Count_Calc=0;
			if(TRACE_CALC_Numb == 0)
			{
				if(m_calc_set_except_all.GetCheck() == 1) //ALL TRACE - ALL EXCEPT
				{
					
					itoa(l3c,&dig_data[0],10);
				::SetWindowText(m_calc_except_result_show.m_hWnd,&dig_data[0]);
				return;
					
				}
				else  //ALL TRACE - SELECT EXCEPT
				{
				
					
							

							::GetWindowText(m_calc_except_number.m_hWnd,&dig_data[0],3);
								int except_number = atoi(&dig_data[0]);

								for(l3c;l3c>0;--l3c)
								{
									
											m_list3.GetItemText(l3c-1,1,&dig_data[0],3);
											if(except_number == atoi(&dig_data[0]))
											{
												Count_Calc++;
											}
									
						

					
						

								}

				}
			}
			else 
			{
						if(m_calc_set_except_all.GetCheck() == 1) //ALL EXCEPT - SELECT TRACE
							{
					
									
						
					
									

											for(l3c;l3c>0;--l3c)
											{
												m_list3.GetItemText(l3c-1,0,&dig_data[0],3);

												if(TRACE_CALC_Numb == atoi(&dig_data[0]))
												{
													
															Count_Calc++;
														
												}
											
											}
						
					
							}
							else //SELECT TRACE - SELECT EXCEPT
							{

								
						

								::GetWindowText(m_calc_except_number.m_hWnd,&dig_data[0],3);
								int except_number = atoi(&dig_data[0]);

								for(l3c;l3c>0;--l3c)
								{
									m_list3.GetItemText(l3c,0,&dig_data[0],3);

									if(TRACE_CALC_Numb == atol(&dig_data[0]))
									{
											m_list3.GetItemText(l3c-1,1,&dig_data[0],3);
											if(except_number == atol(&dig_data[0]))
											{
												Count_Calc++;
											}
									}
								
								}
						

					
					
						}
						

			}

			itoa(Count_Calc,&dig_data[0],10);
			::SetWindowText(m_calc_except_result_show.m_hWnd,&dig_data[0]);
	
}

void Cdiff_traceDlg::OnSetAll() 
{
	// TODO: Add your control notification handler code here
	if(m_calc_set_except_all.GetCheck())
	{
		m_calc_except_number.ShowWindow(false);
	}
	else
	{
		m_calc_except_number.ShowWindow(true);
	}

	
}

void Cdiff_traceDlg::OnTRACENum1() 
{
	// TODO: Add your control notification handler code here
	TRACE_CALC_Numb=CALC_TRACE_1;
}

void Cdiff_traceDlg::OnTRACENum2() 
{
	// TODO: Add your control notification handler code here
	TRACE_CALC_Numb=CALC_TRACE_2;
}

void Cdiff_traceDlg::OnTRACENumAll() 
{
	// TODO: Add your control notification handler code here
	TRACE_CALC_Numb=CALC_TRACE_ALL;
}

void Cdiff_traceDlg::Save_profile_ops(LPSTR FileReff)
{
	GetPrivateProfileString("aaaaaaa","aaaaaaa","aaaaaa","aaaaaaa",50,"aaaaaa");
	
								WritePrivateProfileString(diff_trace__Block,diff_trace__Block_Verion_Key,diff_trace_STR,FileReff);
								::GetWindowText(m_file1.m_hWnd,&dirstr2[0],555);

								WritePrivateProfileString(diff_trace_CompareFiles_Block,diff_trace_CompareFiles_Block_File_1,&dirstr2[0],FileReff);
								::GetWindowText(m_file2.m_hWnd,&dirstr2[0],555);
								WritePrivateProfileString(diff_trace_CompareFiles_Block,diff_trace_CompareFiles_Block_File_2,&dirstr2[0],FileReff);

								unsigned int ProfCount = m_list.GetItemCount();
								my_xtoa_10(ProfCount);
								WritePrivateProfileString(diff_trace_CompareResult_Block,diff_trace_CompareResult_Block_Count_Key,&dig_data[0],FileReff);
								for(ProfCount;ProfCount>0;ProfCount--)
								{
									strcpy(&dirstr2[0],diff_trace_CompareResult_Block_POSITION_1_Key);
									my_xtoa_10(ProfCount);
									strcat(&dirstr2[0],&dig_data[0]);
									m_list.GetItemText(ProfCount-1,0,&buf[0],9);
									WritePrivateProfileString(diff_trace_CompareResult_Block,&dirstr2[0],&buf[0],FileReff);

									strcpy(&dirstr2[0],diff_trace_CompareResult_Block_POSITION_2_Key);
									my_xtoa_10(ProfCount);
									strcat(&dirstr2[0],&dig_data[0]);
									m_list.GetItemText(ProfCount-1,1,&buf[0],9);
									WritePrivateProfileString(diff_trace_CompareResult_Block,&dirstr2[0],&buf[0],FileReff);

									strcpy(&dirstr2[0],diff_trace_CompareResult_Block_ADDRESS_1_Key);
									my_xtoa_10(ProfCount);
									strcat(&dirstr2[0],&dig_data[0]);
									m_list.GetItemText(ProfCount-1,2,&buf[0],9);
									WritePrivateProfileString(diff_trace_CompareResult_Block,&dirstr2[0],&buf[0],FileReff);
									
									strcpy(&dirstr2[0],diff_trace_CompareResult_Block_ADDRESS_2_Key);
									my_xtoa_10(ProfCount);
									strcat(&dirstr2[0],&dig_data[0]);
									m_list.GetItemText(ProfCount-1,3,&buf[0],9);
									WritePrivateProfileString(diff_trace_CompareResult_Block,&dirstr2[0],&buf[0],FileReff);
									}
}




void Cdiff_traceDlg::OnViewerTLs() 
{
	// TODO: Add your control notification handler code here
	TL_View dlg;
	dlg.DoModal();
	
}

void Cdiff_traceDlg::OnStartAsmModeNormal() 
{
	// TODO: Add your control notification handler code here
		if (m_asm_string_mode.GetCheck())
	{

			if(Scan_mode!=SC_ASYNC_WITH_EXCEPTIONS)
		{
	//	Scan_mode=SC_ASYNC_MANUAL;
			
		}
			else
			{
				OnException();
			}
Scan_mode=SC_ASM_STANDART;
	
	

	m_sync.EnableWindow(false);
	m_control_except.EnableWindow(false);
	}
	else
	{
		/*
				if(Scan_mode!=SC_ASYNC_WITH_EXCEPTIONS)
		{
		Scan_mode=SC_SYNC_STANDART;
		}
*/
	
		m_sync.EnableWindow(true);
		m_control_except.EnableWindow(true);
	}


	
}
